/******************** (C) COPYRIGHT 2008 STMicroelectronics ********************
* File Name          : SystemConfig_RTC.h
* Author             : MCD Application Team
* Version            : V1.0.0
* Date               : 07/21/2008
* Description        : System Configuration header file for RTC method.
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

#ifndef __SYSTEM_CONFIG_RTC_H
#define __SYSTEM_CONFIG_RTC_H
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "glasslcd_RTC.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define RCC_APB1Periph_Used_LCD_GPIO  RCC_APB2Periph_GPIOC |\
                                      RCC_APB2Periph_GPIOD |\
                                      RCC_APB2Periph_GPIOE

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/ 
/* Private function prototypes -----------------------------------------------*/
void SystemConfiguration(void);
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void); 
void EXTI_Configuration(void);
void RTC_Configuration(void);
void RTC_Init(void);
	  
/* Private functions ---------------------------------------------------------*/
#endif /* __SYSTEM_CONFIG_RTC_H */

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
