/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : rtc.h
* Author             : MCD Application Team
* Version            : V1.0
* Date               : 10/10/2007
* Description        : This file contains all the functions prototypes for the
*                      RTC firmware library
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __RTC_H
#define __RTC_H
	
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "usart.h"
/* Exported types ------------------------------------------------------------*/

typedef struct 
{
	u8 THH;
	u8 TMM;
	u8 TSS;
}Time_T;

/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void RTC_Configuration(void);
u32 Time_Regulate(void);
void Time_Adjust(void);
void Time_Display(u32 TimeVar);


#endif /* __RTC_H */

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
